<html>
<head>
<title>NASA World Wind Java Applet Notes</title>

<style type="text/css"><!--
body,td,a,p {font-family:arial,sans-serif}
blockquote {background-color: #f0f0f0; padding: 10px; border:1px solid lightgray;}
h2 {margin-top: 2em;color: SaddleBrown; background-color: #dedede; padding-left: 12px;}
h3 {margin-top: 2em; color: DimGray;}
tt {font-size: 1.3em; color: Navy;}
--></style>

</head>

<body>

<h1>NASA World Wind Java Applets</h1>
<small>Last modified september 14, 2007</small>

<h2>Introduction</h2>
This document is intended to help developers through the process of assembling and deploying a <a href="http://worldwind.arc.nasa.gov/java/">World Wind Java</a> applet using <a href="https://applet-launcher.dev.java.net/">Sun's JNLPAppletLauncher</a>.
<p>
</p>


<h2>Requirements</h2>

<p>
As for the whole World Wind Java project, please check the following points :
</p>
<ul>
<li>Up to date video card drivers - especially for OpenGL support.</li>
<li>Java Runtime Environment  (JRE) 1.5.0_07 or more recent.</li>
</ul>
<p>
JOGL applet setup can be tested with this sample Gears 3D JOGL animation applet:<br />
<a href="https://jogl-demos.dev.java.net/applettest.html">https://jogl-demos.dev.java.net/applettest.html</a> 
</p>


<h2>Compiling and running a WWJ applet</h2>

<p>
All you need to deploy a WWJ applet is a web page with the proper html declarations, the WWJ SDK archive <tt>worldwind.jar</tt>, and possibly your special implementation of one of the applet templates in its own archive, eg. <tt>myapplet.jar</tt>.
</p>
<blockquote><pre>
    myapplet.html          Web page that loads the applet
    myapplet.jar           Optional applet class in its own archive
    worldwind.jar          World Wind Java SDK, including applet templates
</pre></blockquote>
<p>
With the JNLPAppletLauncher, all other needed components can be fetched from external servers : the launcher itself <tt>applet-laucher.jar</tt>, and the JOGL librairies <tt>jogl.jar</tt> and <tt>gluegen-rt.jar</tt>. The appropriate binaries will be downloaded and cached according to the client platform by the launcher.
</p>
<p>
To compile and deploy a WW applet, follow the steps below :
</p>
<ol>
<li>Use one of the world wind applet templates from the SDK (see <a href="#APPLET-TEMPLATE">code sample</a> below).</li>
<li>Compile and export worldwind.jar and, if needed, a separate jar for the applet.</li>
<li>Sign all jars (see <a href="#SIGNING">Signing</a> below).</li>
<li>Copy the jar(s) to your deployement folder.</li>
<li>Run with a web page using the JNLPAppletLauncher (see <a href="#LAUNCHER">below</a>)</li>
</ol>
<p>
<b>Important note for Mac</b> : as of september 2007, the Java plugin for mac is still in version 5 - whereas other plateforms can run java 6. If you want to cover all plateforms you need to compile for java 5.
</p>
<p>If your applet uses a custom World Wind configuration file, within a static block of your applet and before
    calling any World Wind method or constructor set the <tt>gov.nasa.worldwind.config.file</tt>
    Java property to the path of your configuration file (see <a href="#CONFIG-SAMPLE">code sample</a> below).
    The path must be relative to the applet's classpath,
    and the configuration file must be included in the applet's signed jar file. World Wind opens the file via
<tt>java.lang.Class.getResourceAsStream().</tt></p> 

<h2>Known issues</h2>

<h3>First use :</h3>
<ul>
<li>Mac / Safari : unresponsive at first then gets better and then fine</li>
<li>Mac / Safari : scroll wheel does not work</li>
<li>Mac / Safari : some javascript errors</li>
<li>Mac / FF : WW applet shows through other pages when tabbing </li>

<li>Win / FF-IE : WW is unresponsive for most of the time, with cpu at 100% - also seen for non applets</li>
<li>Win / IE : Only compass, scalebar and worldmap show, no globe. Placenames come up, but no additional imagery is being displayed - also reported for non applets.</li>
</ul>

<h3>After navigating to other pages and coming back</h3>
<p>
PRESUMABLY FIXED - 2007-07-27 : Applet is 'shut down' whenever the user navigates to another page. When coming back, it is restarted like a new one.
</p>
<ul>
<li>Mac / Safari-FF : the window is white for about five seconds but then the globe does come back and it's responsive. Some tiles from the I3 landsat layer show up after a while and slowly, but the Download indicator never lights up.</li>
<li>Win / FF-IE : the globe comes back like at startup and is responsive, but no additional imagery gets downloaded or displayed.</li>
</ul>


<h2>Code samples</h2>

<a name="APPLET-TEMPLATE">
<h3>WWJ Applet minimal class template</h3>

<blockquote><pre>
import gov.nasa.worldwind.examples.StatusBar;
import gov.nasa.worldwind.*;
import gov.nasa.worldwind.geom.*;
import gov.nasa.worldwind.layers.*;
import gov.nasa.worldwind.awt.*;

import javax.swing.*;
import java.awt.*;

public class WWJApplet extends JApplet
{
    private WorldWindowGLCanvas wwd;
    private StatusBar statusBar;

    public WWJApplet()
    {
    }

    public void init()
    {
        try
        {
            // Create World Window GL Canvas
            this.wwd = new WorldWindowGLCanvas();
            this.getContentPane().add(this.wwd, BorderLayout.CENTER);

            // Create the default model as described in the current worldwind properties.
            Model m = (Model) WorldWind.createConfigurationComponent(AVKey.MODEL_CLASS_NAME);
            this.wwd.setModel(m);

            // Add the status bar
            this.statusBar = new StatusBar();
            this.getContentPane().add(statusBar, BorderLayout.PAGE_END);

            // Forward events to the status bar to provide the cursor position info.
            this.statusBar.setEventSource(this.wwd);

        }
        catch (Throwable e)
        {
            e.printStackTrace();
        }
    }
    
    public void stop()
    {
        // Shutdown World Wind
        WorldWind.shutDown();
    }
}
</pre></blockquote>
</a>

<a name="CONFIG-SAMPLE">
<p>If the applet uses a custom World Wind configuration file, the following would be added to the
    <tt>WWJApplet</tt> class above:</p>
<pre><blockquote>
    static
    {
        System.setProperty("gov.nasa.worldwind.config.file", "config/myWorldWindConfiguration.properties");
    }
</blockquote></pre>
</a>
<p>This property must be set prior to any other World Wind method invocation or object construction.
In this example, the properties file would be contained at the above path within the applet's jar file.</p>

<h3>Preloading a blue marble base image from the 'images' SDK folder</h3>
<p>
When a wwj applet is started the first time with an empty cache, the globe will not show until the level zero tiles of blue marble are downloaded. 
</p>
<p>
To avoid this delay - and big void, add in the layer list, before 'blue marble' a full sphere <tt>SurfaceImage</tt> of a lower resolution whole earth blue marble image, that is embedded in the worldwind jar - and thus preloaded with the applet.
</p>
<p>
In the applet <tt>init()</tt>
</p>
<blockquote><pre>
            // Add a BMNG base layer to the model layer list, before the Blue Marble
            insertBeforeLayerName(this.wwd, new BMNGOneImage(), "Blue Marble");
</pre></blockquote>
<p>
Additional methods
</p>
<blockquote><pre>
    public static void insertBeforeLayerName(WorldWindow wwd, Layer layer, String targetName)
    {
        // Insert the layer into the layer list just before the target layer.
        int targetPosition = 0;
        LayerList layers = wwd.getModel().getLayers();
        for (Layer l : layers)
        {
            if (l.getName().indexOf(targetName) != -1)
            {
                targetPosition = layers.indexOf(l);
                break;
            }
        }
        layers.add(targetPosition, layer);
    }
</pre></blockquote>

<a name="LAUNCHER">
<h3>Using JNLPAppletLauncher</h3>

<p>
Here is the htlm code to use in a web page to run the sample WWJApplet from the SDK applet package. Note that all achives are referenced with absolute urls to Sun's servers except the <tt>worldwind.jar</tt> that is located on another server - probably with this web page, but it could be anywhere.
</p>
<p>
"Note that this example does not specify a codebase, instead specifying all of its archive tag elements with absolute URLs (split here for readability; in a real applet tag they must be all on one line). Note also the use of the noddraw.check parameter to disable the use of DirectDraw since using JOGL implies the use of OpenGL."
</p>

<blockquote><pre>
 &lt;applet code="org.jdesktop.applet.util.JNLPAppletLauncher"
      width=600
      height=400
      archive="http://download.java.net/media/applet-launcher/applet-launcher.jar,
               http://download.java.net/media/jogl/builds/archive/jsr-231-webstart-current/jogl.jar,
               http://download.java.net/media/gluegen/webstart/gluegen-rt.jar,
               http://my.web.server.com/WWJApplet/worldwind.jar">
   &lt;param name="codebase_lookup" value="false">
   &lt;param name="subapplet.classname" value="gov.nasa.worldwind.examples.applet.WWJApplet">
   &lt;param name="subapplet.displayname" value="World Wind Applet">
   &lt;param name="noddraw.check" value="true">
   &lt;param name="progressbar" value="true">
   &lt;param name="jnlpNumExtensions" value="1">
   &lt;param name="jnlpExtension1"
          value="http://download.java.net/media/jogl/builds/archive/jsr-231-webstart-current/jogl.jnlp">
 &lt;/applet>

</pre></blockquote>
<p>
If the applet code is in a separate archive, just add a reference to it in the archive attribute of the applet tag - like after worldind.jar, and specify the proper path in the subapplet.classname parameter:
</p>
<blockquote><pre>
 &lt;applet code="org.jdesktop.applet.util.JNLPAppletLauncher"
      width=600
      height=400
      archive="http://download.java.net/media/applet-launcher/applet-launcher.jar,
               http://download.java.net/media/jogl/builds/archive/jsr-231-webstart-current/jogl.jar,
               http://download.java.net/media/gluegen/webstart/gluegen-rt.jar,
               http://my.web.server.com/WWJApplet/worldwind.jar,
               <b>http://my.web.server.com/WWJApplet/myapplet.jar</b>">
   &lt;param name="codebase_lookup" value="false">
   &lt;param name="subapplet.classname" value="<b>domain.your.path.myApplet</b>">
...
 &lt;/applet>

</pre></blockquote>

<p>
Ref : <a href="https://applet-launcher.dev.java.net/">https://applet-launcher.dev.java.net/</a>
</p>
</a> 



<h3>Applet vs object tag</h3>

<p>
Note : the <tt>applet</tt> tag is considered deprecated in favor of the <tt>object</tt> tag :
</p>
<blockquote><pre>
DEPRECATED EXAMPLE:
The following sample Java applet:

&lt;APPLET code="AudioItem" width="15" height="15">
   &lt;PARAM name="snd" value="Hello.au|Welcome.au">
   Java applet that plays a welcoming sound.
&lt;/APPLET>

may be rewritten as follows with OBJECT:

&lt;OBJECT codetype="application/java"
        classid="AudioItem" 
        width="15" height="15">
   &lt;PARAM name="snd" value="Hello.au|Welcome.au">
   Java applet that plays a welcoming sound.
&lt;/OBJECT>
</pre></blockquote>
<p>
Ref: HTML 4.01 Specifications, December 1999 : Applet<br />
<a href="http://www.w3.org/TR/1999/REC-html401-19991224/struct/objects.html#h-13.4">http://www.w3.org/TR/1999/REC-html401-19991224/struct/objects.html#h-13.4</a>
</p>

<h2>Communication between the web page and the applet</h2>

<h3>Passing parameters to the applet</h3>

<p>
Initial values can be passed to the applet using the <tt>param</tt> tag of the <tt>applet</tt> or <tt>oject</tt> tags:
</p>
<blockquote><pre>
  &lt;param name="paramName" value="some value">
</pre></blockquote>
<p>
From the applet class a parameter value can be retreived with the <tt>getParameter()</tt> method:
</p>
<blockquote><pre>
  String paramValue = getParameter("paramName");
</pre></blockquote>



<h3>Javascript to the applet</h3>

<p>
To allow javascript to 'talk' to the applet, first add an <tt>id</tt> attribute to the <tt>applet</tt> tag :
<p>
<blockquote><pre>
    &lt;applet
         <b>id="wwjApplet"</b>
         code="org.jdesktop.applet.util.JNLPAppletLauncher"
         width=600
         height=400
    ... >
</pre></blockquote>
<p>
To call an applet java method from javascript :
</p>
<blockquote><pre>
  // Call someAppletMethod() via the launcher getSubApplet() method
    
  document.getElementById('wwjApplet').getSubApplet().someAppletMethod();
</pre></blockquote>
<p>
Note the use of the launcher <tt>getSubApplet()</tt> method to get at the applet itself - javascript is really calling the launcher.
</p>
<p>
<b>Important note for Mac</b> : for javascript to be able to 'talk' to the applet, the applet-launcher.jar must be hosted on the same server as the applet. This means that if you need to have javascript/applet interaction across plateforms, you need to host a copy of applet-launcher.jar - and keep it up to date.
</p>
<p>
Ref: Java Plugin Guide : JavaScript to Java Communication (Scripting)<br />
<a href="http://java.sun.com/j2se/1.5.0/docs/guide/plugin/developer_guide/js_java.html">http://java.sun.com/j2se/1.5.0/docs/guide/plugin/developer_guide/js_java.html</a>
</p>


<h3>Applet to javascript and the document object</h3>

To allow the applet to access javascript or the document object, add the <tt>mayscript</tt> attribute to the <tt>applet</tt> tag :
</p>
<blockquote><pre>
    &lt;applet
         <b>mayscript</b>
         code="org.jdesktop.applet.util.JNLPAppletLauncher"
         width=600
         height=400
    ... >

</pre></blockquote>
<p>
To perform a call to javascript from the applet class use <tt>JSObject.getWindow()</tt>:
</p>
<blockquote><pre>
  import netscape.javascript.*;
  ...

  JSObject win = JSObject.getWindow(this);
  win.call("functionName", null);  // calls javascript functionName()

  or

  win.eval("alert('An alert message')"); // evaluates and executes some javascript code as a string
</pre></blockquote>
<p>
Ref: Java Plugin Guide : Java-to-Javascript Communication<br />
<a href="http://java.sun.com/j2se/1.5.0/docs/guide/plugin/developer_guide/java_js.html">http://java.sun.com/j2se/1.5.0/docs/guide/plugin/developer_guide/java_js.html</a>
<p>



<a name="SIGNING">
<h2>Signing archive files</h2>

<p>
To sign your archive files, you need to use <tt>keytool</tt> and <tt>jarsigner</tt> from your JDK bin folder.
</p>
<p>
Assuming the path to keytool and jarsigner is in the PATH environment variable.
</p>
<p>
Create a certificate (once):
</p>
<blockquote><pre>
.../WWJ Applet>keytool -genkey -keyalg rsa -alias yourname

Enter pw : ******

.../WWJ Applet>keytool -export -alias yourname -file yourname.crt
</pre></blockquote>

<p>
Signing a jar : 
</p>
<blockquote><pre>
.../WWJ Applet>jarsigner worldwind.jar yourname

Enter pw : ******
</pre></blockquote>

<p>
Note : this example creates the certificate in the same folder as the applet. This is not necessary.
</p>
<p>
Ref: How to Sign Applets Using RSA-Signed Certificates<br />
<a href="http://java.sun.com/j2se/1.4.2/docs/guide/plugin/developer_guide/rsa_signing.html">http://java.sun.com/j2se/1.4.2/docs/guide/plugin/developer_guide/rsa_signing.html</a>
</p>
</a>


<h2>Security Policy</h2>

<p>
This code bit may be usefull in some situations.
</p>
<blockquote><pre>
        Policy.setPolicy(new Policy() {
            public void refresh() {
            }

            public PermissionCollection getPermissions(CodeSource arg0) {
                Permissions perms = new Permissions();
                perms.add(new AllPermission());
                return (perms);
            }
        });   
</pre></blockquote>



<h2>WWJ Applet examples</h2>

<p>
IGE, France<br />
<a href="http://www.ige.fr/3d/WW/WWJ.php">http://www.ige.fr/3d/WW/WWJ.php</a>
</p>
<p>
Pred, France<br />
<a href="http://atpred.free.fr/applet.html">http://atpred.free.fr/applet.html</a>
</p>
<p>
GIS Solution, Italy<br />
<a href="http://www.gis-solution.com/WWApplet/WWApplet.htm">http://www.gis-solution.com/WWApplet/WWApplet.htm</a>
</p>

<h2>Document history</h2>
<p>
July 2007 - Patrick Murris<br />
First version
</p>


</body>
</html>

